From: Kai Uwe Rommel <rommel@ars.de>
Reply-To: Zip-Bugs@WKUVX1.WKU.EDU, rommel@ars.de
Subject: zip 2.0m, match32.asm
To: zip-bugs@WKUVX1.WKU.EDU (Info-ZIP bug reports)

I have just checked zip 2.0m (a few minor patches will go to Onno
later) and found some time to actually make the os2/match32.asm code
working with IBM's VisualAge C++ 3.0 compiler.

There were some problems that caused it to fail until now including
(probably) a subtle assembler or linker bug that caused the "offset
window" statement to be calculated incorrectly (at runtime, the offset
found in the code was that of window inside the memory object, missing
the memory objects start offset from the beginning of the flat address
space).

After it finally worked, I didn't trust my eyes, for a moment:
compared to the pure C version of zip, compiled with IBM's compiler
and -O, the new version using the os2/match32.asm module was 41%
slower! Did anyone see something like this before? Assembly code
making a program so much _slower_?

Even more strange, the gcc version with the assembly code in match.S
is about 6% faster than the pure C gcc version and about 10% faster
than the pure C IBM C version.

Then I tried the same with the Watcom 10.0 compiler. Similar
result. The version with os2/match32.asm is 15% slower than the pure C
version. And the gcc version with match.S is now even 27% faster than
the pure C Watcom version.

Does anyone have an idea? 

Perhaps something that reduces the CPU's cache hit rate significantly?

Kai Uwe Rommel

--
/* Kai Uwe Rommel      ARS Computer & Consulting GmbH, Muenchen, Germany *
 * rommel@ars.de             CompuServe 100265,2651, Fax +49 89 324 4524 *
 * rommel@leo.org (ftp.leo.org:/pub/comp/os/os2 maintenance)             */

DOS ... is still a real mode only non-reentrant interrupt
handler, and always will be.                -Russell Williams
